<?php
/**
 * Plugin Name:     BackUp WD
 * Plugin URI:      https://web-dorado.com/products/wordpress-backup.html  
 * Description:     Backup WD is an easy-to-use, fully functional backup plugin that allows to backup your website.  
 * Version:         1.0.0
 * Author:          WebDorado
 * Author URI:      https://web-dorado.com
 * License: GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/

define( 'BUWD_MAIN_FILE', plugin_basename( __FILE__ ) );
define( 'BUWD_DIR', dirname( __FILE__ ) );
define( 'BUWD_URL', plugins_url( plugin_basename( dirname( __FILE__ ) ) ) );
define( 'BUWD_VERSION', '1.0.0' );
define( 'BUWD_PREFIX', 'buwd' );

if (version_compare(PHP_VERSION, '5.4.0') >= 0){
    require_once BUWD_DIR . '/vendor/autoload.php';

    require_once( BUWD_DIR . '/includes/buwd.php' );
    require_once( BUWD_DIR . '/includes/buwd-options.php' );

    add_action( 'plugins_loaded', array( 'Buwd', 'get_instance' ) );

    require_once( BUWD_DIR . '/includes/buwd-admin.php' );
    register_activation_hook( __FILE__, array( 'Buwd_Admin', 'activate' ) );
    add_action( 'plugins_loaded', array( 'Buwd_Admin', 'get_instance' ) );
    //deactivation hook
    register_deactivation_hook(__FILE__, array('Buwd_Admin', 'deactivate'));
}
else{
    add_action( 'admin_notices', 'buwd_php_version_admin_notice' );
}

function buwd_php_version_admin_notice() {
    ?>
    <div class="notice notice-error">
        <h3>Backup WD</h3>
        <p><?php _e( 'This version of the plugin requires PHP 5.4.0 or higher.', 'buwd' ); ?></p>
        <p><?php _e( 'We recommend you to update PHP or ask your hosting provider to do that.', 'buwd' );?></p>
    </div>
    <?php
}
